$(document).ready(function () {

    const TRANSLATION_DATA = JSON.parse($('#store-data-translation').val());
    
    $("#mobile_number").bind("keyup", function (e) {
        //const value = $("#mobile_number").val();
        this.value = this.value.replace(/[^0-9]/g, '');
        if ($("#mobile_number").val().match('[0-9]{9}')) {
            $('#mobileNumberHelp').addClass('d-none')
            $('#mobileNumberHelp').removeClass('d-block')
        } else {
            $('#mobileNumberHelp').addClass('d-block')
            $('#mobileNumberHelp').removeClass('d-none')
        }
    })

    $("#school_phone_no").bind("keyup", function () {
        this.value = this.value.replace(/[^0-9]/g, '');
        if ($("#school_phone_no").val().match('[0-9]{9}')) {
            $('#schoolPhoneNoHelp').addClass('d-none')
            $('#schoolPhoneNoHelp').removeClass('d-block')
        } else {
            $('#schoolPhoneNoHelp').addClass('d-block')
            $('#schoolPhoneNoHelp').removeClass('d-none')
        }
    })

    $("#principal_contact_no").bind("keyup", function () {
        this.value = this.value.replace(/[^0-9]/g, '');
        if ($("#principal_contact_no").val().match('[0-9]{9}')) {
            $('#principalContactNoHelp').addClass('d-none')
            $('#principalContactNoHelp').removeClass('d-block')
        } else {
            $('#principalContactNoHelp').addClass('d-block')
            $('#principalContactNoHelp').removeClass('d-none')
        }
    })

    $('#btn-submit').on('click', function () {
        if (!$("#mobile_number").val().match('[0-9]{9}')) {
            $("#mobile_number").focus()
            return
        } else if (!$("#school_phone_no").val().match('[0-9]{9}')) {
            $("#school_phone_no").focus()
            return
        } else if (!$("#principal_contact_no").val().match('[0-9]{9}')) {
            $("#principal_contact_no").focus()
            return
        }
        validate_file();
    })


    function resetFieldsValidations(crrType) {
        $('#school-community-registration-form input').prop('required', true);
        if (crrType === 'community') {
            $('input[name="school_address"]').prop('required', false);
            $('input[name="school_email_address"]').prop('required', false);
            $('input[name="school_phone_no"]').prop('required', false);
            $('input[name="file"], #userUploadFile').prop('required', false);
        } else if (crrType === 'teacher') {
            $('input[name="community_leader_email"]').prop('required', false);
            $('input[name="file"], #userUploadFile').prop('required', false);
            $('input[name="principal_name"]').prop('required', false);
            $('input[name="principal_contact_no"]').prop('required', false);
        } else if (crrType === 'principal') {
            $('input[name="community_leader_email"]').prop('required', false);
        } else {
            $('input[name="community_leader_email"]').prop('required', false);
            $('input[name="file"], #userUploadFile').prop('required', false);
            $('input[name="principal_name"]').prop('required', false);
            $('input[name="principal_contact_no"]').prop('required', false);
        }
    }

    function labelPlaceHolderChanger(array) {
        array.forEach((object) => {
            let query = object.query;
            let text = object.text;
            let placeholder = object.placeholder;

            let element = $(query);
            let formGroup = $( element.closest('.form-group') );
            let label = $( formGroup.find('label') );

            label.html(text);
            element.attr('placeholder', placeholder);
        });
    }

    function hideShowFormGroupByArrayQueries(arrayNames, show = false) {
        arrayNames.forEach((name) => {
            let element = $(name);
            let formGroup = $( element.closest('.form-group') );

            if (show) {
                formGroup.removeClass('d-none');
            } else {
                formGroup.addClass('d-none');
            }
        });
    }

    function onTypeIsChanged(type) {
        let requiredIcon = ' <i class="icon fa fa-exclamation-circle text-danger fa-fw " title="Required field" aria-label="Required field"></i>';

        let defaultLabels = [
            {
                query: 'input[name="school_name"]',
                text: TRANSLATION_DATA.label_school_name + requiredIcon,
                placeholder: TRANSLATION_DATA.label_school_name,
            },
            {
                query: 'input[name="principal_name"]',
                text: TRANSLATION_DATA.label_principal_name + requiredIcon,
                placeholder: TRANSLATION_DATA.label_principal_name,
            },
            {
                query: 'input[name="principal_contact_no"]',
                text: TRANSLATION_DATA.label_principal_contact_number + requiredIcon,
                placeholder: TRANSLATION_DATA.label_principal_contact_number,
            },
            {
                query: 'input[name="school_address"]',
                text: TRANSLATION_DATA.label_school_address + requiredIcon,
                placeholder: TRANSLATION_DATA.label_school_address,
            },
            {
                query: 'input[name="school_email_address"]',
                text: TRANSLATION_DATA.label_school_email + requiredIcon,
                placeholder: TRANSLATION_DATA.label_school_email,
            },
            {
                query: 'input[name="school_phone_no"]',
                text: TRANSLATION_DATA.label_school_contact_number + requiredIcon,
                placeholder: TRANSLATION_DATA.label_school_contact_number,
            },
        ];

        let queriesToHide = [];
        let labelsToChange = [];
        
        $('#school-community-registration-form .form-group').removeClass('d-none');

        if (type === 'community') {
            labelsToChange = [
                {
                    query: 'input[name="school_name"]',
                    text: TRANSLATION_DATA.label_community_name + requiredIcon,
                    placeholder: TRANSLATION_DATA.label_community_name,
                },
                {
                    query: 'input[name="principal_name"]',
                    text: TRANSLATION_DATA.label_community_leader_name + requiredIcon,
                    placeholder: TRANSLATION_DATA.label_community_leader_name,
                },
                {
                    query: 'input[name="principal_contact_no"]',
                    text: TRANSLATION_DATA.label_community_leader_contact_number + requiredIcon,
                    placeholder: TRANSLATION_DATA.label_community_leader_contact_number,
                },
            ];
            queriesToHide = [
                'input[name="school_address"]',
                'input[name="school_email_address"]',
                'input[name="school_phone_no"]',
                '#form-guid-line',
                '#userUploadFile',
            ];
        } else if (type === 'teacher') {
            queriesToHide = [
                'input[name="principal_name"]',
                'input[name="principal_contact_no"]',
                '#form-guid-line',
                '#userUploadFile',
                'input[name="community_leader_email"]',
            ];
            labelsToChange = defaultLabels;
        } else if (type === 'principal') {
            queriesToHide = [
                'input[name="community_leader_email"]',
            ];
            labelsToChange = defaultLabels;
        } else {
            queriesToHide = [
                'input[name="principal_name"]',
                'input[name="principal_contact_no"]',
                '#form-guid-line',
                '#userUploadFile',
                'input[name="community_leader_email"]',
            ];
            labelsToChange = [
                {
                    query: 'input[name="school_name"]',
                    text: TRANSLATION_DATA.label_organization_name + requiredIcon,
                    placeholder: TRANSLATION_DATA.label_organization_name,
                },
                {
                    query: 'input[name="school_address"]',
                    text: TRANSLATION_DATA.label_organization_address + requiredIcon,
                    placeholder: TRANSLATION_DATA.label_organization_address,
                },
                {
                    query: 'input[name="school_email_address"]',
                    text: TRANSLATION_DATA.label_organization_email + requiredIcon,
                    placeholder: TRANSLATION_DATA.label_organization_email,
                },
                {
                    query: 'input[name="school_phone_no"]',
                    text: TRANSLATION_DATA.label_organization_contact_number + requiredIcon,
                    placeholder: TRANSLATION_DATA.label_organization_contact_number,
                },
            ];
        }

        labelPlaceHolderChanger(labelsToChange);
        hideShowFormGroupByArrayQueries(queriesToHide);

        resetFieldsValidations(type);
    }

    // form validation
    // window.validate = () => {
    //     return validate_file();
    // }

    window.validate_file = () => {
        const file_error_element = $('#file_err_alert');
        const file_name_preview = $('#file_name_preview p');
        const upload_pdf = $('#userUploadFile');
        const file = $('#userUploadFile')[0].files[0]
        let isValidated = true;
        let alertLabel = TRANSLATION_DATA.label_please_upload_application_form;
        
        // hide error alert
        file_error_element.addClass('d-none');
    
        if (file == undefined) {
            isValidated = false;
        } else {
            const fileType = file.type; // holds the file types
            const match = ["application/pdf"]; // defined the file types
            if (!((fileType == match[0]) || (fileType == match[1]))) {
                isValidated = false;
                alertLabel = TRANSLATION_DATA.label_incorrect_file_format;
            }
        }
    
        if (isValidated) {
            let fileName = file.name;
            file_name_preview.text(fileName);
        } else {
            upload_pdf.val("");
            file_name_preview.text(null);
            $(file_error_element.find('p')).text(alertLabel);
            file_error_element.removeClass('d-none');
        }
    }

    $('input[name="flexRadio"]').on('change', function (e) {
        let target = e.target;
        let value = $( target ).val();
        onTypeIsChanged(value);
    })


    let savedType = $('input[name="save_type_after_submit"]').val();
    if (savedType) {
        onTypeIsChanged(savedType);
    } else {
        onTypeIsChanged('principal');
    }
})